# Virtualizaciones y contenedores

## Instalación de _virtualBox_

Instalamos desde los repos de Ubuntu

```bash
sudo apt install virtualbox virtualbox-ext-pack virtualbox-guest-additions-iso virtualbox-guest-x11
```

## Docker

Tenemos que añadir el repositorio correspondiente a nuestra
distribución:

~~~~
# Be safe
for pkg in docker.io docker-doc docker-compose docker-compose-v2 podman-docker containerd runc; do sudo apt-get remove $pkg; done
sudo apt autoremove
sudo apt update

# Install pre-requisites
sudo apt install ca-certificates curl gnupg lsb-release

# Add Docker's official GPG key:
sudo apt-get update
sudo apt-get install ca-certificates curl
sudo install -m 0755 -d /etc/apt/keyrings
sudo curl -fsSL https://download.docker.com/linux/ubuntu/gpg -o /etc/apt/keyrings/docker.asc
sudo chmod a+r /etc/apt/keyrings/docker.asc

# Add the repository to Apt sources:
echo \
  "deb [arch=$(dpkg --print-architecture) signed-by=/etc/apt/keyrings/docker.asc] https://download.docker.com/linux/ubuntu \
  $(. /etc/os-release && echo "${UBUNTU_CODENAME:-$VERSION_CODENAME}") stable" | \
  sudo tee /etc/apt/sources.list.d/docker.list > /dev/null
sudo apt-get update

# Update the package database

sudo apt update

# Check repos
apt-cache policy docker-ce

# Install
sudo apt install docker-ce docker-ce-cli containerd.io docker-buildx-plugin docker-compose-plugin

sudo gpasswd -a username docker
~~~~

Esto dejará el servicio _docker_ funcionando y habilitado (arrancará
en cada reinicio del ordenador)

La forma de pararlo es:

~~~~bash
sudo systemctl stop docker
sudo systemctl disable docker
systemctl status docker
~~~~

Añadimos el _bundle_ __docker__ en nuestro fichero `~/.zshrc` para
tener autocompletado en comandos de docker.

Para usar _docker_ tendremos que arrancarlo, con los alias de nuestro sistema para _systemd_ ejecutamos:

~~~~bash
scst docker  # para arrancar el servicio

scsp docker  # para parar el servicio
~~~~
